//dialog box
#include <vector>
#include <allegro.h>
#include "gameconsts.h"
#include "map.h"
#include <string>

using namespace std ;

#define TEXT_COLOR 5
#define BOX_COLOR 3
#define BOXBORDER_COLOR TEXT_COLOR

void TextBox(vector<string> dialogArray, unsigned int locX, unsigned int locY)
{
	unsigned int lineCtr=0; // made unsigned
	int lengthInPixels=0;// made unsigned
	unsigned int heightInPixels=text_height(font)+10;// made unsigned
	

	heightInPixels=heightInPixels*dialogArray.size() ;
	//get the longest lengthInPixels amd number of lines of dialogue
	for (lineCtr=0; lineCtr<dialogArray.size(); lineCtr++)
		if (lengthInPixels<text_length(font,dialogArray[lineCtr].c_str()))
			lengthInPixels=text_length(font,dialogArray[lineCtr].c_str());

	//text_mode(-1);  //Moved to init subroutine
	//draw rectangles
	rectfill(framebuf, locX+10, locY+10, (locX+lengthInPixels)+15, 
			(int)(locY+(heightInPixels))+10, makecol(0,0,0));  // added (int) !warning
	rectfill(framebuf, locX+5, locY+5, (locX+lengthInPixels)+10, 
			(int)(locY+(heightInPixels))+5, makecol(128,128,128)); // added (int) ..
	rect(framebuf, locX+5, locY+5, (locX+lengthInPixels)+10, 
			(int)(locY+(heightInPixels))+5, makecol(255,255,255)); // added (int) ..

	//output text to screen
	heightInPixels=text_height(font)+10;
	for (lineCtr=0; lineCtr<dialogArray.size();lineCtr++)
		textout(framebuf, font, dialogArray[lineCtr].c_str(), locX+10, 
				(int)(locY+(heightInPixels*lineCtr)+10), makecol(255,255,255 )); // added (int) !warning

	blit(framebuf, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
}


string optionBox(vector<string> optionArray, int posX = 40, int posY = 40)
{
	//std::vector<string>::iterator pos;
	std::vector<string> textVect;
	//pos = optionArray.begin();
	textVect.clear();
	textVect.push_back(optionArray[0]);
	textVect.push_back(" ");
	int maxItems = optionArray.size(), option=2;
	cout << maxItems << ": Max items" << endl;
	if (maxItems == 0)
	{	textVect.push_back("No Items"); TextBox(textVect, posX, posY); while (!key[ACTION_KEY] && !key[CANCEL_KEY]) vsync();
		while (key[ACTION_KEY] || key[CANCEL_KEY]) vsync(); return "";
	}
	else
	{
	textVect.clear();
			textVect.push_back(optionArray[0]);
	  		for (int i = 1; i < maxItems; ++i)	textVect.push_back("   ");
	  		textVect[option] = " > ";
			for (int i = 1; i < maxItems; ++i)	{	textVect[i] += optionArray[i];	}	
			textVect[option] += " < ";
			TextBox(textVect, 200, SCREEN_HEIGHT-100);
	while (!key[ACTION_KEY] && !key[CANCEL_KEY])
		{
			
			if (key[KEY_UP] || key[KEY_DOWN])
			{	 // back to begining of list			
				if (key[KEY_UP])	
				{	
					if (option > 2) option--;
				}
				if (key[KEY_DOWN])	
				{	
					if (option < maxItems-1) option++;
				}
	////////////////
			textVect.clear();
			textVect.push_back(optionArray[0]);
	  		for (int i = 1; i < maxItems; ++i)	textVect.push_back("   ");
	  		textVect[option] = " > ";
			for (int i = 1; i < maxItems; ++i)	{	textVect[i] += optionArray[i];	}	
			textVect[option] += " < ";
			TextBox(textVect, 200, SCREEN_HEIGHT-100);
	////////////////
		
			if (key[KEY_UP] || key[KEY_DOWN]){for(int delay=0; delay<20; delay++)vsync();}// delay
			}
		}	
		cout << "The word of the day is... " << optionArray[option] << endl;
		if (key[CANCEL_KEY]) return "";
		return optionArray[option];
	}
	TextBox(textVect, posX, posY);
}


