#ifndef __RPGCONSTS__
#define __RPGCONSTS__

#include "character.h" // this will need to be global
#include <allegro.h>

extern Hero hero;

#define MAPSIZE_X 129 // 120
#define MAPSIZE_Y 129 // 128
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480

#define ACTION_KEY  KEY_T
#define MENU_KEY	KEY_M
#define CANCEL_KEY  KEY_C


typedef void (*pt2Function)();

extern DATAFILE* data;
extern BITMAP* backdrop, *framebuf;

extern int mapOriginX, mapOriginY;// = 4, mapOriginY = 16;
extern int X, Y;//=//100, Y=150;
extern char direction;// = 'e';
extern BITMAP * mainMap;

extern pt2Function mapAction[10];
extern int attackProb[512];

extern short mapTileData[MAPSIZE_X][MAPSIZE_Y];// =
//int worldTileData[MAPSIZE_X][MAPSIZE_Y] =
/*
  {{ 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 3, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 1},
   { 3, 1, 1, 1, 1, 3, 3, 4, 3, 3, 3, 3, 3, 1},
   { 3, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 1, 1, 3, 3, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 4, 1, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 1, 1, 3, 3, 1, 1, 1, 1, 1, 1, 1},
   { 3, 1, 1, 1, 1, 3, 3, 1, 1, 1, 1, 1, 1, 1}};
*/
extern char mapInformation[MAPSIZE_X][MAPSIZE_Y];// =

//int worldMap [MAPSIZE_X][MAPSIZE_Y] =      // includes walkability, and 
/*  {{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}, //   lookup number of what is
   { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, //   located at that position
   { 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, //   i.e. a character, or map
   { 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, //   entrance
   { 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 3, 0, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0},
   { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
*/

#endif