#include "character.h"
#include "gameconsts.h"
#include <multimap.h>
#include <algorithm>
#include <math.h>
#include <string>
#include "optionsMenu.h" //itoa
#include "dialogBox.h"

void Hero::AddGold(int a)
{
	gold += a;
}

int Hero::GetGold()
{
   return gold;
 }

bool Hero::UseGold(int a)
{
	if (gold > a) {gold -= a; return true; } return false;
}
itemList Hero::GetItems()
{
	return items;
}
void Hero::AddItem(string a)
{ 
	transform ( a.begin(), a.end(), a.begin(), tolower);
	items.insert(a);
}
bool Hero::UseItem(string a)
{
	std::multimap<string, ptr2func>::iterator mmPos;
	std::itemList::iterator msPos;
	msPos = items.find(a);
	// Check item exists, 
	if (msPos != items.end())
	{
		mmPos = use.find(a);
		if (mmPos != use.end())
		{
			cout << "Using Item ";
			mmPos->second();  // function pointer to the action associate with the thing
			items.erase(msPos);
			return true;
		}
	}
	cout << "Sorry, No item or FP" << endl;
	return false; // item not found
}




int Person::defend(int attackValue)
{
	(attackValue < HP)? HP -= attackValue : HP = 0;
	return attackValue; // We wnat to defend the attack, also needs to be more complex	
}
int Person::attack()
{
	
	return Strength;  // PRobably want this a bit more complex, with a rand qualtiy of hit
}

Enemy::Enemy()
{
	name = "??";
}
int Enemy::GetGold()	{ return gold; }
int Enemy::GetExperience(){return experience; }


Enemy::Enemy(string nm, int gld, int exp, int hp, int mp, int str, int def, itemList itms)
{
	name = nm; gold = gld; experience = exp; SetMaxHP(hp); SetMaxMP(mp);
	SetStrength(str); SetDefense(def);
	///// Add items to the list
	items = itms;  // this work??
}
Enemy::Enemy(string nm, int gld, int exp, int hp, int mp, int str, int def)
{
	name = nm; gold = gld; experience = exp; SetMaxHP(hp); SetMaxMP(mp);
	SetStrength(str); SetDefense(def);
	
}
string Enemy::GetName()
{
	return name;
}



Hero::Hero()
{
	name = "??";
	experience = 0;
	level = 0;
	initItems();
}
string Hero::GetName()
{
	return name;
}
void Hero::AddExperience(int exp)
{	// CHECK TO SEE IF LEVEL INCREASES!!!! (More than once??)
	experience += exp;
	int NextLevel = pow(2, level) * 10;
	vector <string> output;
	
	while (experience > NextLevel)
	{
		output.clear();
		NextLevel = pow(2, level) * 10;
		level++;
		cout << "Level increased!" << endl;
		output.push_back("  LEVEL INCREASED TO " + itoa(level) + "!  ");
		output.push_back("");
		// Determine amount of increase
		if (level%3)
		{
			output.push_back(" HP increased 30%");
			output.push_back(" Strength Increased 4 Points ");
			output.push_back(" Defense Increased 4 Points ");
			SetMaxHP(GetHP() * 1.30);
			SetStrength(GetStrength() + 4);
			SetDefense(GetDefense() + 4); 
		}
		else if (level%2)
		{
			output.push_back(" HP increased 20%");
			output.push_back(" Strength Increased 2 Points ");
			output.push_back(" Defense Increased 2 Points ");
			
			SetStrength(GetStrength() + 2);
			SetDefense(GetDefense() + 2);
			SetMaxHP(GetHP() * 1.20);	
		}
		else 
		{
			output.push_back(" HP increased 10%");
			output.push_back(" MP increased 20% ");
			
			SetMaxMP(GetMP() * 1.20);
			SetMaxHP(GetHP() * 1.10);
		}
		// output message
		TextBox(output, SCREEN_WIDTH/4,SCREEN_HEIGHT/3);
		
		while (!key[ACTION_KEY]) vsync();
		while (key[ACTION_KEY]) vsync();
	}
}

int Hero::GetLevel(){ return level; }
int Hero::GetExperience(){return experience; }

Hero::Hero(int hpin, int mpin, int levelin, int exp, const char* namein)
{	
	experience = exp; 
	level = levelin; 
	SetMaxHP(hpin);
	SetMaxMP(mpin);
	name = namein;
	gold = 0;
	initItems();
}
void potion()  ////// PROBABLY BELONGS SOMEWHERE ELSE!!
{
	hero.SetHP(hero.GetHP() + 150); 
}
void herb()  ////// PROBABLY BELONGS SOMEWHERE ELSE!!
{
	hero.SetHP(hero.GetHP() + 50); 
}
void Hero::initItems()
{
	use.insert(std::make_pair("potion", &potion));
	use.insert(std::make_pair("herb", &herb));
}

Person::Person()
{}
void Person::SetStrength(int value)	{	Strength = value;	}
void Person::SetDefense(int value)	{	Defense = value;	}
void Person::SetHP(int points)		{	(MaxHP > points)? HP = points: HP = MaxHP;	}
void Person::SetMP(int points)		{	MP = points;	}
void Person::SetMaxHP(int points)	{	MaxHP = points;	SetHP(points);}
void Person::SetMaxMP(int points)	{	MaxMP = points;	SetMP(points);}
int Person::GetStrength()			{	return Strength;	}
int Person::GetDefense()			{	return Strength;	}
int Person::GetMaxHP()	{	return MaxHP;	}
int Person::GetMaxMP()	{	return MaxMP;	}
int Person::GetHP()		{	return HP;	}
int Person::GetMP()		{	return MP;	}
