#include <allegro.h>

#include "palette.h"
#include <iostream.h>
#include "map.h"
#include "battle.h"
#include "gameconsts.h"
#include "optionsMenu.h"
#include "dialogBox.h"
#include "initialize.h"
#include "mapMovement.h"
#include <vector> 
#include "shop.h"



// should go in support routines
inline int max(int a, int b) { 	if (a > b) return a; return b; }




int main()
{
	// give initial options??, load main map should be elsewhere
	initializeGame(); // check to see if it returns true/ esp with saved game
	// load initial map and characters?
	
	/// Initial Screen
	
	
	/////Opening Dialog HERE
	//set_alpha_blender();
	set_trans_blender(255,109,255, 128);
	BITMAP * characterB = create_bitmap(32, 32);
	blit(mainMap, characterB, 64,1312 , 0,0, 32, 32);// this is the character sprite
		
	////// END DIALOG
	
	while(!(key[KEY_LSHIFT] && key[KEY_ESC])) //??? WE WANT THIS OVERALL??
	{
		blit(backdrop, framebuf, mapOriginX, mapOriginY, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

		draw_trans_sprite(framebuf, characterB, X-mapOriginX, Y-mapOriginY);
//		blit(mainMap, framebuf, 64,1312 , X-mapOriginX, Y-mapOriginY, 32, 32);// this is the character sprite
														// should be an actual sprite
		vsync();
		blit(framebuf, screen, 0,0,0,0, SCREEN_WIDTH, SCREEN_HEIGHT);
		poll_joystick();
		
		if (key[KEY_LEFT]			|| joy_left)	{	MoveLeft(); MoveLeft(); MoveLeft();	}
		else if (key[KEY_RIGHT] 	|| joy_right)	{	MoveRight(); MoveRight(); MoveRight();}
		if (key[KEY_UP] 			|| joy_up)		{	MoveUp();  MoveUp(); MoveUp();	}
		else if (key[KEY_DOWN] 		|| joy_down)	{	MoveDown(); MoveDown(); MoveDown();	}
		if (key[ACTION_KEY]) { action(); } // needs a key || Joy something
		if (key[MENU_KEY])	 { optionsMenu(); }
		if (key[KEY_S])		{ testShop(); }
		if (key[KEY_N])		{ talk2Girl(); }
	}
	// ASK TO SAVE LATER??
	
	return 0;
}
END_OF_MAIN();
