#include <allegro.h>

#include "palette.h"
#include <iostream.h>
#include "map.h"
#include "battle.h"
#include "gameconsts.h"
#include "optionsMenu.h"
#include "dialogBox.h"
#include "initialize.h"
#include <vector> 

// if both walkable, return 0, else return most interesting (highest #)
//	  conflicts should be avoided, i.e. don't place 2 important things
//	  near eachother
inline int checkDown()
{
	int x= X/32;
	int y= ((Y)/32)+1;
	if ((X)%32 != 0)
	{
		if (mapInformation[x][y]==1 && mapInformation[x+1][y]==1)
		{		return 1;	}
		else 	return max(mapInformation[x][y], mapInformation[x+1][y]);
	} 	return mapInformation[x][y];
}
inline int checkUp()
{
	int x= X/32;
	int y= ((Y-1)/32);//Y-1
	if ((X)%32 != 0)
	{
		if (mapInformation[x][y]==1 && mapInformation[x+1][y]==1)
		{		return 1;	}
		else 	return max(mapInformation[x][y], mapInformation[x+1][y]);
	}	return	mapInformation[x][y];
}
inline int checkLeft()
{
	int x= ((X-1)/32);	int y= Y/32;
	if ((Y)%32 != 0)
	{
		if (mapInformation[x][y]==1 && mapInformation[x][y+1]==1)
		{		return 1;	}
		else 	return max(mapInformation[x][y], mapInformation[x][y+1]);
	} 	return mapInformation[x][y];
}
inline int checkRight()
{
	int x= ((X)/32)+1;//X+1
	int y= Y/32;
	if ((Y)%32 != 0)
	{	
		if (mapInformation[x][y]==1 && mapInformation[x][y+1]==1)
		{		return 1;	}
		else 	return max(mapInformation[x][y], mapInformation[x][y+1]);
	}	return mapInformation[x][y];
}


void action()
{
// See what is in the area
//   Treasure, Door, Person
	
// Do the action, 
	int checkVal = 0;
	switch (direction)      // each of the check functions return the 
	{						//  Number of the thing of interest, do it.
		case 'e':
			cout << "East" << endl;
			checkVal = checkRight();
			if (checkVal > 1) // look east
			{
				mapAction[checkVal]();
				cout << "Something is there!" << endl;
			}
			break;
		case 'w':
			cout << "West" << endl;
			checkVal = checkLeft();
			if (checkVal > 1) // look east
			{
			mapAction[checkVal]();
				cout << "Something is there!" << endl;
			}
			break;
		case 's':
			cout << "South" << endl;
			checkVal = checkDown();
			if (checkVal > 1) // look east
			{
			mapAction[checkVal]();
				cout << "Something is there!" << endl;
			}
			break;
		case 'n':
			cout << "North" << endl;
			checkVal = checkUp();
			if (checkVal > 1) // look east
			{
			mapAction[checkVal]();
				cout << "Something is there!" << endl;
			}
			break;
		default: cout << "???" << endl; break;
	}
}


// THESE WERE INLINE!!!
void MoveLeft()
{
	direction = 'w';
	randBattle();
	if (checkLeft() == 0)	
	{	
		if (X < mapOriginX + 50)
		{
			mapOriginX--;
		}
		X--;	
	}
}
void MoveRight()
{
	direction = 'e';
	randBattle();
	if (checkRight() == 0)	
	{	
		if (X > mapOriginX - 82 + SCREEN_WIDTH)
		{
			mapOriginX++;	
		}
		X++;	
	}
}
void MoveUp()
{
	direction = 'n';
	randBattle();
	if (checkUp() == 0)		
	{	
		if (Y < mapOriginY + 50)
		{
			mapOriginY--;	
		}
		Y--;
	}
}
void MoveDown()
{
	direction = 's';	
	randBattle();
	if (checkDown() == 0)	
	{	
		if (Y > mapOriginY - 82 + SCREEN_HEIGHT)
		{
			mapOriginY++;
		}
		Y++;	
	}
}

